      implicit double precision (a-g,o-y),integer (h-n,z)
  
      include 'perplex_parameters.h'
 
      character*8 names,fname*10
 
      common/ cst8 /names(k1)/ csta7 /fname(h9)
     *      / cst6  /icomp,istct,iphct,icp
     *      / cst79 /isoct
     *      / cst41 /n1,n2,n3,n4,n5,n6,n7,n8,n9,io3,io4,io5,io9

      n9 = 10

      open (10,file='dummy.dat')
      open (11,file='output')
      read (10,*) iphct
      do i = 1, iphct
         read (10,1000) names(i)
      end do
      read (10,*) isoct
      do i = 1, isoct
         read (10,1010) fname(i)
      end do 

1010  format (a10)
1000  format (a8)
      call input9
      end

      subroutine input9 
c-----------------------------------------------------------------------
c given a list of solution phase names (fname(h9)) input9 searches a
c data file (on unit n9) for the relevant data and subdivides the
c solutions into pseudo-compounds.
c-----------------------------------------------------------------------
      implicit double precision (a-g,o-z),integer (h-n)
  
      include 'perplex_parameters.h'

      parameter (ms1=msp-1)
 
      character*10 tname, uname(2)*8, sname(h9), fname, names*8

      double precision z(mst,msp)
 
      common/ cst108 /wg(27,11),xmn(mst,msp),xmx(mst,msp),xnc(mst,msp),
     *      xfx(msp),iend(msp,msp,msp),isub(27,9,2),imd(3),
     *      imsol(msp,msp,msp),ijk(mst),insp(mst,msp),jsp(mst),
     *      jsitp(mst),iosp(mst),jst(mst),jfix,idfc(3),ist(mst),
     *      isp(mst),isite,ispct(mst,msp),jnsp(mst,msp),jsite,iterm,iord
     *      / cst86 /xy(ms1,k1),y(k1,mst,ms1),ntot,npairs
     *      / cst107 /a0(5,5),acoef(5,5,m0),smult(5),ecoef(msp,msp,msp),
     *                nsite,nspm1(5),nterm(5,5),
     *                nsub1(5,5,m0,4),nsub2(5,5,m0,4),nttyp(5,5,m0)
     *      / cst60 /ipoint,imyn/ csta7 /fname(h9)
     *      / cst41 /n1,n2,n3,n4,n5,n6,n7,n8,n9,io3,io4,io5,io9
     *      / cst79 /isoct/ cst6  /icomp,istct,iphct,icp
     *      / cst1  /thermo(k4,k10),uf(2),us(h5)
     *      / cst61 /ikp(k1),ivarrx(k2),ivarip(k2),isudo,ivar
     *      / cst304 /sxs(k13),exces(3,k1),jend(h9,k12),ixp(k1),ifp(k1)
     *      / cst8  /names(k1)
      save uname

      data uname/' ',' '/
c-----------------------------------------------------------------------
c                               set compound counter ipoint.
      ipoint = iphct
      ixct = 0 
c                               initialize match flag:
      im = 0
c                               no request for solutions, goto 999:
      goto (999),io9
c                               read the solution name
10    call rmodel (tname,istot)

      if (istot.eq.0) goto 99
c                               check the solution model:
      call cmodel (im,idsol,tname,istot,jstot,0,uname(1),uname(2))

      if (jstot.eq.0) goto 10 
c                               
      if (jstot.lt.istot) then
c                               if ok, determine a valid
c                               endmember subset.
         call emodel (tname,istot)
c                               edit model parameters:
         if (istot.eq.0) then
c                               couldn't revise model
            im = im - 1
            goto 10
         end if 

         call nmodel

      end if
c                               save found solutions:
      sname(im) = tname
c                               if nsite ne 0 get "normalization"
c                               constants for entropy model:
      if (nsite.ne.0) call snorm (tname)
c                               generate pseudocompound compositions.
c                               subdiv returns the total
c                               number of pseudocompounds (ipcps) and 
c                               array y, of which element y(h,i,j) is
c                               the site fraction of the jth species on
c                               the ith site of the hth pseudocompound.
      call subdiv (tname)
c                               load default site fractions
c                               into the unused sites of the
c                               site fraction array:
      if (isite.lt.3) then
         do i = isite + 1, mst
            z(i,1) = 1d0
            do j = 3, msp
               z(i,j) = 0d0
            end do           
         end do 
      end if          
c                               subdiv generates ntot compositions,
c                               generate the compound data for
c                               each solution:
c                               save the identities of the endmembers
      jend(im,1) = isp(1)*isp(2)*isp(3)
      if (jend(im,1)+2.gt.k12) call error (39,zt,k12,'INPUT9')
      icpct = 0
      itic = 2

      do i = 1, isp(1)
         do j = 1, isp(2)
            do k = 1, isp(3)
               itic = itic + 1
c                               if the endmember has not been
c                               "killed" by a solution model
c                               set the solution identifier flag.
               if (ikp(imsol(i,j,k)).ne.-1) ikp(imsol(i,j,k)) = im 
               jend(im,itic) = imsol(i,j,k)
            end do 
         end do 
      end do 

      do h = 1, ntot
c                               load the composition into
c                               a the site fraction array:
         do i = 1, isite
            zt = 0d0
            do j = 1, isp(i) - 1
               z(i,j) = y(h,i,j)
               zt = zt + z(i,j)
            end do 
            z(i,isp(i)) = 1d0 - zt
         end do 
c                               generate the pseudocompound:
         call soload (z,im,icpct,ixct,tname)
      end do 

      jend(im,2) = icpct

      if (im.eq.isoct) goto 999
c                             next solution
      goto 10 
c                             at least one solution phase referenced
c                             in the input is not included in the
c                             solution phase data file, write warning:
99    call warn (43,zt,isoct-im,'INPUT9')
c                             scan for "killed endmembers"
999   do i = 1, iphct
c                             reset ikp
         if (ikp(i).lt.0) ikp(i) = 0
      end do 

      if (isoct.gt.0) then 
         write (n3,1020)
         write (n3,1010) (fname(i), i = 1, isoct)
         if (im.gt.0) then 
            write (n3,1000)
            write (n3,1010) (sname(i), i = 1, im)
         else 
            write (n3,1040) 
         end if 

         do i = 1, im
            fname(i) = sname(i)
         end do 
      end if 

      isoct = im

1000  format (/,' the following solution models will be considered:',/)
1010  format (7(2x,a10))
1020  format (/,' Of the requested solution models:',/)
1040  format (/,' no models will be considered.',/)

      end 

      subroutine soload (z,isoct,icpct,ixct,tname)
c--------------------------------------------------------------------------
c soload - loads/requires solution properties: 

c   jend(h9,k12)  - h9 is the maximum number of solutions
c                   k12 is the maximum number of endmembers pers
c                   solution plus two.
c   jend(i,1)     - is the number of endmembers in solution i.
c   jend(i,2)     - is the number of pseudocompounds of solution i.
c   jend(i,3-3+j) - are the indices of the j endmembers in solution i.
c   sxs(k13)      - contains the mole fractions of the endmembers
c                   in the pseudocompounds.
c   ixp(i)        - a pointer that locates the first mole fraction (- 1)
c                   of the ith pseudocompound, the remaining mole fractions
c                   follow sequentially (as in jend(i,3-3+j)).
c   ikp(i)        - the index of the solution corresponding to pseudocompound i.
c   ifp(i)        - flag, 1 if pseudocompound i is a fluid, else 0.
c   exces(j,i)    - the excess function of pseudocompound i, accounts for 
c                   excess properties and configurational entropy as a function
c                   of pressure and temperature:

c                       gexces(i) = exces(1) + exces(2)*T + exces(3)*P
c--------------------------------------------------------------------------

      implicit double precision (a-g,o-z),integer (h-n)
  
      include 'perplex_parameters.h'

      character*10 tname, names*8
 
      double precision z(mst,msp)

      integer ints(8)

      common/ cst41 /n1,n2,n3,n4,n5,n6,n7,n8,n9,io3,io4,io5,io9
     *      / cst108 /wg(27,11),xmn(mst,msp),xmx(mst,msp),xnc(mst,msp),
     *      xfx(msp),iend(msp,msp,msp),isub(27,9,2),imd(3),
     *      imsol(msp,msp,msp),ijk(mst),insp(mst,msp),jsp(mst),
     *      jsitp(mst),iosp(mst),jst(mst),jfix,idfc(3),ist(mst),
     *      isp(mst),isite,ispct(mst,msp),jnsp(mst,msp),jsite,iterm,iord
     *      / cst107 /a0(5,5),acoef(5,5,m0),smult(5),ecoef(msp,msp,msp),
     *                nsite,nspm1(5),nterm(5,5),
     *                nsub1(5,5,m0,4),nsub2(5,5,m0,4),nttyp(5,5,m0)
     *      / cst12 /cp(k5,k1)
     *      / cst1  /thermo(k4,k10),uf(2),us(h5)
     *      / cst6  /icomp,istct,iphct,icp/ cst8 /names(k1)
     *      / cst61 /ikp(k1),ivarrx(k2),ivarip(k2),isudo,ivar
     *      / cst5  /p,t,xco2,u1,u2,tr,pr,r,ps
     *      / cst40 /ids(h5,h6),isct(h5),icp1,isat,io2
     *      / cst300 /cblk(k5),atw(k1),jbulk,io3b
     *      / cst304 /sxs(k13),exces(3,k1),jend(h9,k12),ixp(k1),ifp(k1)
     *      / cst10  /iff(2),idss(h5),ifug,ifyn,isyn
c                              eliminate end-member compositions
      do i = 1, isp(1)
         call zchk (z(1,i),tname)
         do j = 1, isp(2)
            call zchk (z(2,j),tname)
            do k = 1, isp(3)
               call zchk (z(3,k),tname)
               if (z(1,i)*z(2,j)*z(3,k).gt.0.999d0) goto 999
            end do
         end do 
      end do     
c                               eliminate out of range compositions:  
c                               is this necessary?
      do 10 i = 1, isite
         if (imd(i).gt.0) goto 10
         do j = 1, isp(i) - 1
            if (z(i,j).gt.xmx(i,j).or.z(i,j).lt.xmn(i,j)) goto 999
         end do   
10    continue 
c                               the composition is acceptable.
      iphct = iphct + 1
      icpct = icpct + 1

      if (iphct.gt.k1) call error (41,z(1,1),k1,'SOLOAD')

      ikp(iphct) = isoct
      ixp(iphct) = ixct
c                               encode a name
      itic = 0
      do i = 1, isite
         do j = 1, isp(i) - 1
            itic = itic + 1
            ints(itic) = idint(1d2*z(i,j))
            if (ints(itic).gt.99) ints(itic) = 99
         end do
      end do
c
      if (isite.eq.1.and.itic.lt.3) then
         if (isp(1).eq.2) then
c                                binary solutions
           if (z(1,1).ge.0.04d0.and.z(1,1).le.0.96d0) then
              write (names(iphct),1030) names(imsol(1,1,1)),ints(1)
           else   
              write (names(iphct),1070) names(imsol(1,1,1)), 1d2*z(1,1)
           end if 

         else if (isp(1).eq.3) then
c                                ternary solutions
            write (names(iphct),1040) names(imsol(1,1,1)),ints(1),
     *                                names(imsol(2,1,1)),ints(2)

         end if 

      else if (isite.eq.2.and.itic.lt.3) then
 
          write (names(iphct),1020) names(imsol(1,1,1)),ints(1),ints(2)
 
      else if (itic.lt.4) then 

          write (names(iphct),1060) names(imsol(1,1,1)),
     *                              (ints(i),i=1,itic)

      else if (itic.eq.4) then 

          write (names(iphct),1080) (ints(i),i=1,itic)
          write (n3,1000) names(iphct),(((z(1,i)*z(2,j)*z(3,k),
     *                    names(imsol(i,j,k)),i=1,isp(1)),
     *                                          j=1,isp(2)),
     *                                          k=1,isp(3))

      else 
c                              this is a pretty shitty name
c                              but for the time being your going to
c                              have live with it.
         do i = 1, itic
            ints(i) = ints(i)/10
         end do
         if (itic.gt.8) itic = 8

         if (itic.lt.7) then 
            write (names(iphct),1090) names(imsol(1,1,1)),
     *                                (ints(i), i = 1, itic)
         else if (itic.lt.8) then 
            write (names(iphct),1100) names(imsol(1,1,1)),
     *                                (ints(i), i = 1, itic)
         else 
            write (names(iphct),1010) (ints(i), i = 1, itic)
         end if 

         write (n3,1000) names(iphct),(((z(1,i)*z(2,j)*z(3,k),
     *                   names(imsol(i,j,k)),i=1,isp(1)),j=1,isp(2)),
     *                                                   k=1,isp(3))
 
      end if
c                              get blanks out of name:
      if (itic.lt.3) then 
         call unblnk (names(iphct)) 
      else 
         call reblnk (names(iphct)) 
      end if   
c                              initialize constants:
      smix = 0d0
      esum = 0d0
      atw(iphct) = 0d0
      ctotal = 0d0
c
      do i = 1, isp(1)
         do j = 1, isp(2)
            do 20 k = 1, isp(3)

               zp = z(1,i)*z(2,j)*z(3,k)
               ixct = ixct + 1
               if (ixct.gt.k13) call error (40,zp,k13,'SOLOAD')
               sxs(ixct) = zp
               if (zp.eq.0d0) goto 20

               id = imsol(i,j,k)
               esum = esum + zp * ecoef(i,j,k)
               atw(iphct) = atw(iphct) + zp * atw(id)

20          continue
         end do 
      end do  

c                              compute ideal configurational negentropy:
      if (nsite.eq.0.and.ist(1).ne.0) then  
         do i = 1, isite 
            do j = 1, isp(i)
               if (z(i,j).ne.0d0) smix = smix + 
     *                            float(ist(i))*z(i,j)*dlog(z(i,j)) 
            end do 
         end do     
      else if (nsite.ne.0) then
         call omega (z,dlnw,tname)
         smix = -dlnw + esum
      end if 
c                              save it:
      exces(2,iphct) = exces(2,iphct) + r * smix
c                              load excess terms:
      if (iterm.ne.0) then
         do i = 1, iterm
            zp = 1d0

            do j = 1, iord
               if (isub(i,j,1).ne.0) zp= zp * z(isub(i,j,1),isub(i,j,2))
            end do  

            do j = 1, 3
               exces(j,iphct) = exces(j,iphct) + zp * wg(i,j)
            end do 

         end do  
      end if 

1000  format (' icky name ',a8,' = ',4(4(f5.3,1x,a4,1x),/))
1010  format (8i1)
1020  format (a2,i2,'_',i2)
1030  format (a2,i2)
1040  format (a1,i2,a1,i2)
1060  format (a2,i2,i2,i2)
1070  format (a2,f4.1)
1080  format (4i2)
1090  format (a2,6i1)
1100  format (a1,7i1)

999   end

      subroutine grxn (gval) 
c-----------------------------------------------------------------------
c grxn computes the free energy of univariant equilibria
c defined by the data in commonn block cst21 which is initialized
c in the subprogram balanc.  grxn is partially redundant with
c the function gphase but because of the frequency that these
c these routines are used a significant increase in efficiency is
c gained by maintaining separate functions.
c-----------------------------------------------------------------------
      implicit double precision (a-g,o-z),integer (h-n)

      end

