      PROGRAM PSCONTOUR 
 
      implicit real (a-g,o-z),integer (h-n)
 
      character*100 fname
 
      common / basic /n4,ifont,icopt,jwidth,iop0
      common / xyrat /xfac
 
      n4 = 24
      n5 = 25 
c                                    default font
      ifont = 7
c                                    default line width
      jwidth = 1

      xfac = 1e0
 
      write (*,1020) 
      read (*,1000) fname
 
      open (n4,err=90,file=fname,status='old')

      write (*,1021) 
      read (*,1000) fname
 
      open (n5,err=90,file=fname,status='old')

20    call psopen (fname,ier)
      goto (999), ier
  
      call psxypl (n5)
 
      goto 99
90    write (*,1040) fname
      goto 999
91    write (*,1050) fname
      goto 999
 
99    call psclos
 
      close (99)
 
1000  format (a)
1020  format (/,'Enter the CONTOUR plot file #1:')
1021  format (/,'Enter the CONTOUR plot file #2:')
1030  format (/,'Modify the default plot (y/n)?')
1040  format (/,'No such file as:',a,/)
1050  format (/,'file:',/,a,/,' is not formatted correctly.',/)
1060  format (80a1)

999   end

c---------------------------------------------------------------------
      subroutine psxypl (n5)
 
c psxypl - subroutine to output x-y plot.

      implicit real (a-g,o-z),integer (h-n)

      include 'perplex_parameters.h'

      character y*1, vname*8, fname*162
 
      parameter (nx=500,ny=500)

      common/ vs    /vmin(l3),vmax(l3),iv/ vsa /vname(l3)
     *      / basic /n4,ifont,icopt,jwidth,iop0
	common/ dim   /z(nx,ny),zt(nx,ny),ix,iy
      common/ stuff /zmax,zmin
      common/ wsize /xmin,xmax,ymin,ymax,dcx,dcy,xlen,ylen

      read (n4,1000) fname
      read (n4,*) ix,iy,xmin,ymin,dx,dy
      read (n4,1010) (vname(i),i=1,2)
      read (n5,1000) fname
      read (n5,*) ix,iy,xmin,ymin,dx,dy
      read (n5,1010) (vname(i),i=1,2)
      if (ix.gt.nx .or. iy.gt.ny ) then 
         write (*,*) ' wrong dimensioning increase parameter nx/ny'
         goto 99 
      end if 

      read (n4,*) ((z(i,j), i = 1, ix), j = 1, iy)
	read (n5,*) ((zt(i,j), i = 1, ix), j = 1, iy)

      do i = 1, nx
         do j = 1, ny
            z(i,j) = z(i,j)/zt(i,j)
         end do
      end do 

      ypmn = ymin
      xpmn = xmin
      ypmx = ymin + (iy-1)*dy
      xpmx = xmin + (ix-1)*dx    
      ymax = ypmx
      xmax = xpmx     

      write (*,1060) 
      read (*,'(a)') y
      if (y.eq.'y') then 
         write (*,1070) ypmx,ypmn,xpmx,xpmn
         read (*,*) ypmx,ypmn,xpmx,xpmn
      end if 

1070  format (/,'Old values were: ',4(g12.4),/,' Enter new values:')
1060  format (/,'Reset plot limits (y/n)?')

      iox = ix
      ioy = iy

      if (y.eq.'y') then 
         jmn = ypmn/dy + 1
         jmx = ypmx/dy + 1
         imn = xpmn/dx + 1
         imx = xpmx/dx + 1
         iy = (jmx-jmn+1)
         ix = (imx-imn+1)
         ymax = ypmn + (iy-1)*dy
         ymin = ypmn 
         xmin = xpmn
         xmax = xpmn + (ix-1)*dx
      end if 
c                                      reload mini matrix:
      if (y.eq.'y') then
         do i = 1, ix
            do j = 1, iy
               z(i,j) = z(i+imn-1,j+jmn-1)
            end do
         end do
      end if 

      vmin(1) = xmin
      vmin(2) = ymin
      vmax(1) = xmax
      vmax(2) = ymax
c                                 get some options and
c                                 set up transformations
      call psaxop (jop0,fac1)
        
      zmin = 1.d10
      zmax = -1.d10
c                                      set up contour intervals                                      
      do i = 1, ix
         do j = 1, iy 
            if (z(i,j).lt.zmin) zmin = z(i,j)
            if (z(i,j).gt.zmax) zmax = z(i,j)
         end do 
      end do 
c                                      set up contour intervals
      write (*,*) ' Contoured variable range', zmin, zmax 
      write (*,*) ' Modify default contour interval (y/n)?'
      read (*,'(a1)') y
      if (y.eq.'y') then
         write (*,*) ' Enter min, max and interval for contours:'
         read (*,*) cmin, cmax, dcon
         ncon = (cmax-cmin)/dcon + 1.1
      else 
         dcon = (zmax-zmin)/11.
         cmax = zmax - 0.5 * dcon
         cmin = zmin + 0.5 * dcon
         ncon = 11
      end if 

      call pscontor (cmin,ncon,dcon)

      call pssctr (8,1.,1.,0.)
 
      call psaxes (jop0)
 
1000  format (a)
1010  format (10a8)
1030  format (8a10)
1040  format (20a5)

99    end

c----------------------------------------------------------------------
      subroutine psaxop (jop0,fac)

c psaxop - subroutine to make graphics transformation and get some options

      implicit real (a-g,o-z),integer (h-n)

      character yes*1, vname*8

      include 'perplex_parameters.h'

      common/ vs    /vmin(l3),vmax(l3),iv/ vsa /vname(l3)
      common/ wsize /xmin,xmax,ymin,ymax,dcx,dcy,xlen,ylen
      common/ xyrat /xfac/ basic /n4,ifont,icopt,jwidth,iop0


      dsx = 0.18
      dsy = 0.18
      dtx = 160.
      dty = 220.
      drot = 0.
      jop0 = 0
      iop8 = 1
      jwidth = 1 
      fac = 0.6


c                                     modify default drafting
c                                     options?          
      write (*,1090) 
      read (*,1030) yes
      if (yes.eq.'y'.or.yes.eq.'Y') jop0 = 1


      if (jop0.eq.1) then
 
10       write (*,1100)
         read (*,1030) yes

         if (yes.eq.'y'.or.yes.eq.'Y') then

            write (*,1110) dsx,dsy,dtx,dty,drot
            read (*,*) dsx,dsy,dtx,dty,drot

         end if 

         write (*,1130)
         read (*,1030) yes

         if (yes.eq.'y'.or.yes.eq.'Y') then

            write (*,1140) 
            read (*,*) xfac

         end if 

20       write (*,2000)
         read (*,1030) yes
         if (yes.eq.'y'.or.yes.eq.'Y') then 
            write (*,2020) 
            read (*,*) fac
            if (fac.le.0.) then
               write (*,1200) fac
               goto 20 
            end if
         end if 

         if (icopt.eq.3) goto 30 

         write (*,1120) 
         read (*,1030) yes
         if (yes.eq.'y'.or.yes.eq.'Y') jwidth = 0
c                                       splines, yes = 0
         write (*,1210) 
         read (*,1030) yes
         if (yes.ne.'y'.and.yes.ne.'Y') iop8 = 0
 
      end if

30    xmax = vmax(1)
      xmin = vmin(1)
      ymax = vmax(2)
      ymin = vmin(2)
      xlen = xmax - xmin
      ylen = ymax - ymin
c                                     set default char size, based
c                                     on font 7 (helv 14) the axes
c                                     length is about 85 characters
      dcx = xlen / 85.
      dcy = ylen / 85.
 
      call psssc2 (xmin,xmax,ymin,ymax)

      dsx = dsx * xfac
 
      call psstrn (dsx,dsy,dtx,dty,drot)

1030  format (a)
1040  format (/,'Enter new min and max for ',a,' old values ',
     *        ' were: ',2(g11.5,1x))
1070  format (/,'Modify x-y limits (y/n)? ')
1080  format ('OK, this may look sloppy.')
1090  format (/,'Modify default drafting options (y/n)?',/,
     *          '  answer yes to modify:',/,
     *          '   - picture transformation',/,
     *          '   - x-y plotting limits',/,
     *          '   - relative lengths of axes',/,
     *          '   - text label font size',/,
     *          '   - line thickness',/,
     *          '   - curve smoothing',/,
     *          '   - axes labeling and gridding')
1100  format (/,'Modify default picture transformation (y/n)?')
1110  format (/,'The default values for x-y scaling, x-y',
     *          ' translation, and rotation',/,'are, respectively:',
     *        /,(5(4x,g8.3)),/,'Enter new values: ')
1120  format (/,'Use minimum width lines (y/n)?')
1130  format (/,'Modify ratio of x to y axis length (y/n)')
1140  format (/,'Enter fractional length of x-axis relative',
     *          ' to y-axis: ')
1200  format (/,1x,g13.6,' is an invalid value.',/)
1210  format (/,'Fit curves with B-splines (y/n)? ')
2000  format (/,'Modify default text scaling (y/n)? ')
2020  format (/,'Enter scaling factor: ')

      end 

      subroutine pscontor (cmin,ncon,dcon)
C----------------------------------------------------------------
C suncontour is a program to contour in x-y space.   
C----------------------------------------------------------------
C INPUT:
C
C NX, NY - number of x and y values, respectively.
C DX, DY - spacing of points in x and y directions, 
c          respectively.
C Z(I,J),I=1,NX,J=1,NY - value of the potential at each x-y 
C          point.
C----------------------------------------------------------------
      IMPLICIT REAL (A-G,O-Z), INTEGER (H-N)

      parameter (nseg=100000,npts=250000,npcs=100000,mcon=50)
      parameter (nx=500,ny=500)

      character kontor*80
    
      real cont(mcon),clinex(npts),
     *     cliney(npts),linex(1000),liney(1000),cline(2,npts),
     *     segs(4,nseg)

      integer ipieces(2,npcs),npiece(mcon),ifirst(mcon),
     *        next(nseg),ilast(mcon)

      common/ dim   /z(nx,ny),zt(nx,ny),ix,iy
      common/ stuff /zmax,zmin
      common/ wsize /xmin,xmax,ymin,ymax,dcx,dcy,xlen,ylen
c----------------------------------------------------------------            
c                                  contor interval
      do i = 1, ncon
         cont(i) = cmin + (i-1) * dcon
      end do 

      do i = 1, ix 
         do j = 1, iy 
              zt(j,i)= z(i,j)
         end do
      end do 

      write (kontor,1000) dcon, cmin, cont(ncon)  
      call pssctr (7,1.,1.,0.0)
      call pstext (xmin-2.*dcx,ymax+8.*dcy,kontor,0)
      write (kontor,1010) zmin, zmax
      call pstext (xmin-2.*dcx,ymax+5.*dcy,kontor,0)

      call contra (xmin,xmax,ymin,
     *             ymax,ncon,cont,clinex,cliney,cline,segs,
     *             npts,nseg,npcs,ipieces,npiece,
     *             ifirst,next,ilast)

      ipiece = 1
      iswit = 0
      do k = 1, ncon

         iswit = iabs (iswit-1)

         if (iswit.eq.0) then
            rline = 7
         else
            rline = 1
         end if

         if (k.eq.1.or.k.eq.ncon) then 
            ithick = 2
         else 
            ithick = 0
         end if 

         np = npiece(k)
         if (np.gt.0) then 
            do i = 1, np
               ipts = ipieces(2,ipiece)
               if (ipts.ne.0) then 
                  do j = 1, ipts
                     istart = ipieces(1,ipiece)
                     linex(j) = clinex(istart+j-1)
                     liney(j) = cliney(istart+j-1)
                  end do

                  call psbspl (linex,liney,ipts,rline,ithick,0)
               end if 
               ipiece = ipiece + 1
            end do 
         end if
      end do 

1010  format ('Cont Variable Range ',g10.4,' -> ',g10.4)
1000  format ('Cont Int ',g10.4,' Cont Range ',g10.4,' -> ',g10.4)

      end     

      subroutine contra (xmin,xmax,ymin,ymax,ncon,cont,
     *                   clinex,cliney,cline,segs,npts,
     *                   nseg,npcs,ipieces,npiece,ifirst,next,
     *                   ilast)
c----------------------------------------------------------------------
c          cp      value to be contoured in a square array
c          ny     no of values in y direction
c          nx     no of values in x direction
c          xmin,xmax min and max values in x
c          ymin,ymax min and max value sin y
c          ncon    no of contopur levels.
c          cont    array containing contour levels.
c          clinex,cliney x,y pairs of points on contour segments.
c          ipieces array of pointers for contour segments.
c                  1,n start of coordinates in clinex cliney for
c                  current segment.
c                  2,n no of x,y pairs in current segment.
c          npiece  no of segments in each contour.
c
c
c       author:
c
c         martin casey 13-07-88
c       modified to use 4 data triangles, jadc 10-89
c------------------------------------------------------------------------
      parameter (nx=500,ny=500)

      logical iscon
  
      dimension c(3),x(3),y(3),cont(ncon),ipieces(2,npcs),
     *          npiece(ncon),cline(2,npts),clinex(npts),cliney(npts),
     *          segs(4,nseg),ifirst(ncon),next(nseg),ilast(ncon)

      common/ dim /z(nx,ny),zt(nx,ny),ix,iy

      dx = (xmax - xmin) / float(ix -1)
      dy = (ymax - ymin) / float(iy -1)

      do k = 1,ncon
         ifirst(k) = 0
         ilast(k) = 0
      end do 

      nextg = 0
      do k = 1,nseg
         next(k) = 0
      end do

      dy2 = dy/2e0
      dx2 = dx/2e0
    
      do i = 1, iy-1
         do j = 1, ix-1
c                                            set the common vertex
          c(3) = (zt(i,j)+zt(i+1,j)+zt(i,j+1)+zt(i+1,j+1))/4.0
          x(3) = xmin + (float(j)-0.5)*dx
          y(3) = ymin + (float(i)-0.5)*dy
c                                            first triangle, (i,j) (i,j+1)
          c(1) = zt(i,j)
          c(2) = zt(i,j+1)
          x(1) = x(3)-dx2
          x(2) = x(3)+dx2
          y(1) = y(3)-dy2
          y(2) = y(1)

          call cfind (c,cont,ncon,iconlt,numcon,iscon)
          if (numcon .gt. 0) call cdraw 
     *       (c,x,y,cont,ncon,iconlt,numcon,nseg,
     *                 segs,ifirst,next,ilast)

c                                            second triangle, (i+1,j) (i+1,j+1)
          c(1) = zt(i+1,j)
          c(2) = zt(i+1,j+1)
          y(1) = y(3)+dy2
          y(2) = y(1)

          call cfind (c,cont,ncon,iconlt,numcon,iscon)
          if (numcon .gt. 0) call cdraw 
     *       (c,x,y,cont,ncon,iconlt,numcon,nseg,
     *                 segs,ifirst,next,ilast)

c                                            third triangle, (i,j),(i+1,j)
          c(2) = c(1)
          c(1) = zt(i,j)
          x(2) = x(1)
          y(1) = y(3)-dy2 

          call cfind (c,cont,ncon,iconlt,numcon,iscon)
          if (numcon .gt. 0) call cdraw 
     *       (c,x,y,cont,ncon,iconlt,numcon,nseg,
     *                 segs,ifirst,next,ilast)

c                                            fourth triangle, (i,j+1),(i+1,j+1)
          c(1) = zt(i,j+1)
          c(2) = zt(i+1,j+1)
          x(1) = x(3)+dx2
          x(2) = x(1)

          call cfind (c,cont,ncon,iconlt,numcon,iscon)
          if (numcon .gt. 0) call cdraw 
     *       (c,x,y,cont,ncon,iconlt,numcon,nseg,
     *                 segs,ifirst,next,ilast)

         end do 
      end do 

      tol = 1e-10
      inow = 0
      ipiece = 1
      do 220 k = 1,ncon
	npiece(k) = 0
        if (ilast(k) .eq. 0) go to 220
        iseg = ifirst(k)
  145   continue
        ic = 2
        cline(1,1) = segs(1,iseg)
        cline(2,1) = segs(2,iseg)
        cline(1,2) = segs(3,iseg)
        cline(2,2) = segs(4,iseg)
        xf = segs(1,iseg)
        yf = segs(2,iseg)
        xn = segs(3,iseg)
        yn = segs(4,iseg)
        lines = 0
  150   continue
        isegn = next(iseg)
        lines = lines + 1
        if (iseg .eq. ilast(k)) go to 170
        do 160 i = 1, 1000000
c          if (isegn .eq. ilast(k)) go to 170
          x1 = segs(1,isegn)
          y1 = segs(2,isegn)
          x2 = segs(3,isegn)
          y2 = segs(4,isegn)
          if (((xn - x1)**2 + (yn - y1)**2) .lt. tol) then
            ic = ic + 1
            cline(1,ic) = x2
            cline(2,ic) = y2
            if (isegn .eq. ilast(k)) then
              ilast(k) = iseg
            else
              next(iseg) = next(isegn)
            endif
            iseg = ifirst(k)
            isegn = next(iseg)
            xn = x2
            yn = y2
          else if (((xn - x2)**2 + (yn - y2)**2) .lt. tol) then
              ic = ic + 1
              cline(1,ic) = x1
              cline(2,ic) = y1
              if (isegn .eq. ilast(k)) then
                ilast(k) = iseg
              else
                next(iseg) = next(isegn)
              endif
              iseg = ifirst(k)
              isegn = next(iseg)
              xn = x1
              yn = y1
            else
              iseg = isegn
              isegn = next(iseg)
          endif
          if (iseg .eq. ilast(k)) go to 170
  160   continue
  170   continue
        if (lines .eq. 2) go to 180
        if (((xn - xf)**2 + (yn - yf)**2) .lt. tol) go to 180
          icf = ic
          xn = xf
          yn = yf
          iseg = ifirst(k)
          go to 150
  180   continue
        iseg = ifirst(k)
        isego = iseg
        ifirst(k) = next(iseg)
        iseg = ifirst(k)
	npiece(k) = npiece(k) + 1
      if (ipiece.gt.npcs) then 
         write (*,*) ' increase npcs (',npcs,') and recompile'
         stop
      end if
	ipieces(1,ipiece) = inow + 1
c        write(6,1000) ifirst(k),ilast(k),isego
 1000   format(3i10)
        if (lines .eq. 1) then
          do i = 1,ic
            xpc = cline(1,i)
            ypc = cline(2,i)
	      inow = inow + 1
            if (inow.gt.npts) then
               write (*,*) ' increase npts and recompile'
               stop
            end if 
            clinex(inow) = xpc
            cliney(inow) = ypc
          end do 
          else
            icf1 = icf + 1
            icl = ic +1
            do i = icf1,ic
              inow = inow + 1
            if (inow.gt.npts) then
               write (*,*) ' increase npts and recompile'
               stop
            end if 
              icl = icl - 1
              xpc = cline(1,icl)
              ypc = cline(2,icl)
              clinex(inow) = xpc
              cliney(inow) = ypc
            end do 
            do i = 1,icf
              inow = inow + 1
            if (inow.gt.npts) then
               write (*,*) ' increase npts and recompile'
               stop
            end if 
              
              xpc = cline(1,i)
              ypc = cline(2,i)
              clinex(inow) = xpc
              cliney(inow) = ypc
             end do 
          end if
	  ipieces(2,ipiece) = ic 
          ipiece = ipiece + 1
          if(isego .ne. ilast(k)) go to 145
  220 continue

      end

      subroutine cfind(c,cont,ncon,iconlt,numcon,iscon)
c
c      purpose
c
c       find if a contour crosses a data triangle
c
c      author:
c
c       martin casey 13-07-88
c
      logical iscon

      dimension c(3),cont(ncon)

      iscon = .false.
      numcon = 0
      cmax = -1e10
      cmin = 1e10
      do k = 1,3
         if(cmax .lt. c(k) ) cmax = c(k)
         if(cmin .gt. c(k) ) cmin = c(k)
      end do 
      if (cmax .eq. cmin ) return
      iconlo = 0

      do i = 1,ncon
         iconlo = iconlo + 1
         if(cont(iconlo) .ge. cmin) go to 120
      end do 

  120 if(cont(ncon) .lt. cmin) return

      iconhi = ncon

      do i = 1,ncon
        if(cont(iconhi) .lt. cmax) go to 140
        iconhi = iconhi - 1 
      end do

  140 if (cont(1) .gt. cmax) return
      if (iconhi .lt. iconlo) return
      iscon = .true.
      numcon = iconhi - iconlo + 1
      iconlt = iconlo

      end

      subroutine cdraw(c,x,y,cont,ncon,iconlt,numcon,nseg,
     *                 segs,ifirst,next,ilast)
c----------------------------------------------------------------
c      purpose:
c
c       draw contours across a data triangle
c
c      author:
c
c       martin casey 13-07-88
c-----------------------------------------------------------------
      dimension x(3),y(3),c(3),cont(ncon)

      dimension segs(4,nseg),ifirst(ncon),next(nseg),ilast(ncon)

      cmax = -1e10
      cmin = 1e10

      do k = 1,3
        if(cmax .lt. c(k)) then
          cmax = c(k)
          kmax = k
        endif
        if(cmin .gt. c(k)) then
          cmin = c(k)
          kmin = k 
        endif
      end do

      do k = 1,3
        kmid = k
        if (k.ne.kmin.and.k.ne.kmax) go to 120
      end do

  120 k = iconlt - 1

      do kx = 1,numcon
        k = k + 1
        delc = cont(k) -cmin
        prop = delc /(cmax - cmin)
        x1 = x(kmin) + (x(kmax) - x(kmin)) * prop
        y1 = y(kmin) + (y(kmax) - y(kmin)) * prop

        if (c(kmid) .gt. cont(k)) then
          delc = cont(k) - cmin
          prop = delc / (c(kmid) - cmin)
          x2 = x(kmin) + (x(kmid) - x(kmin)) * prop
          y2 = y(kmin) + (y(kmid) - y(kmin)) * prop
        else
          delc = cont(k) - cmax
          prop = delc /(cmax - c(kmid))
          x2 = x(kmax) + (x(kmax) - x(kmid)) * prop
          y2 = y(kmax) + (y(kmax) - y(kmid)) * prop
        end if

        nextg = nextg + 1
        if (nextg.gt.nseg) then 
           write (*,*) ' Increase parameter NSEG and recompile PSCONTOR'
           stop
        end if 

        if (ilast(k) .eq. 0 ) then
          ifirst (k) = nextg
          ilast(k) = nextg
        else
          ix = ilast(k)
          next(ix) = nextg
          ilast(k) = nextg
        endif

        segs(1,nextg) = x1
        segs(2,nextg) = y1
        segs(3,nextg) = x2
        segs(4,nextg) = y2
      end do 

      end

c----------------------------------------------------------------------
      subroutine psaxes (jop0)
 
c psaxes - subroutine to output (sloppy) axes.

      implicit real (a-g,o-z),integer (h-n)
 
      character*8 vname, record*20, yes*1
 
      include 'perplex_parameters.h'

      common/ vs    /vmin(l3),vmax(l3),iv/ vsa /vname(l3)
      common/ wsize /xmin,xmax,ymin,ymax,dcx,dcy,xlen,ylen
      common/ xyrat /xfac/ basic /n4,ifont,icopt,iwidth,iop0
 
      ihalf = 1
      itenf = 0
      igrd = 0
      rline = 1.

      csn = 1.
      csa = 1.

      x0 = xmin
      y0 = ymin
      dx = xlen / 5.
      dy = ylen / 5.

      xtic  = xlen/45.
      xtic1 = xtic*.67
      xtic2 = xtic1*.67
 
      ytic  = ylen/45.
      ytic1 = ytic*.67
      ytic2 = ytic1*.67 

      if (jop0.eq.1) then
         write (*,1010) 
         read (*,1020) yes
         if (yes.ne.'y'.and.yes.ne.'Y') goto 10

         write (*,1030) 'X', x0, dx
         read (*,*) x0, dx
         write (*,1030) 'Y', y0, dy
         read (*,*) y0, dy

         write (*,1040)
         read (*,1020) yes
         if (yes.eq.'y'.or.yes.eq.'Y') ihalf = 0

         write (*,1050) 
         read (*,1020) yes
         if (yes.eq.'y'.or.yes.eq.'Y') itenf = 1

         write (*,1070) 
         read (*,1020) yes
         if (yes.eq.'y'.or.yes.eq.'Y') then 
            write (*,1060) 
            read (*,*) csn, csa
         end if

         write (*,1080) 
         read (*,1020) yes 
         if (yes.eq.'y'.or.yes.eq.'Y') igrid = 1    
      end if 
c                                       draw axes box
10    call psrect (xmin,xmax,ymin,ymax,1.,iwidth,0)
c                                       draw left vertical axis tics
      call psytic (xmin, y0, dy, xtic, xtic1, xtic2, rline, 
     *             ihalf, itenf)
c                                       draw right vertical axis
      call psytic (xmax, y0, dy, -xtic, -xtic1, -xtic2, rline, 
     *             ihalf, itenf)
c                                       draw bottom horizontal axis
      call psxtic (ymin, x0, dx, ytic, ytic1, ytic2, rline,
     *             ihalf, itenf)
c                                       draw top horizontal axis
      call psxtic (ymax, x0, dx, -ytic, -ytic1, -ytic2, rline, 
     *             ihalf, itenf)
 
      call pssctr (7,csn*1.2,csn*1.2,0.)

      cx = dcx * csn
      cy = dcy * csn 
c                                       numeric axis labels:
      call psylbl (xmin, xmax, y0, ymax, dy, cx, cy, tmin, igrd) 
 
      call psxlbl (x0, dx, cx, 2.3*cy, igrd)

      cx = dcx * csa
      cy = dcy * csa
c                                       x-axis name
      call pssctr (7,csa*2.,csa*2.,0.0)
      t = xmin + 0.5 * xlen - (7. * cx) / xfac
      call pstext (t, ymin - 0.07 * ylen, vname(1),0)
c                                       y-axis name
      call pssctr (7,csa*2.,csa*2., 90.)
      t = tmin - 5. * cx / xfac 
      call pstext (t, ymin + 0.43 * ylen,vname(2),0)
c                                       sectioning constraints
      if (iv.gt.2) then
 
         call pssctr (8,csa*1.2,csa*1.2,0.)
         y = ymax + 0.12 * ylen
         do 1 i = 3, iv
            write (record,1000) vname(i),vmin(i)
            call pstext (xmin,y,record,0)
1           y = y - 0.037 * ylen
 
      end if
 
1000  format (a,'=',g9.3)
1010  format (/,'Modify default axes (y/n)?')
1020  format (a)
1030  format (/,'Enter the starting value and interval for',
     *          ' major tick marks on',/,'the ',a,'-axis (',
     *          'current values are:',2(1x,g9.3),')',/, 
     *          'Enter new values:')
1040  format (/,'Cancel half interval tick marks (y/n)?')
1050  format (/,'Draw tenth interval tick marks (y/n)?')
1060  format (/,'Enter scale factors for numeric and text',
     *          ' axes labels:') 
1070  format (/,'Rescale axes text (y/n)?')
1080  format (/,'Turn gridding on (y/n)?')
      end

      subroutine psytic (x0, y0, dy, tic, tic1, tic2, rline, ihalf,
     *                   itenf)

      implicit real (a-g,o-z),integer (h-n)

      common/ wsize /xmin,xmax,ymin,ymax,dcx,dcy,xlen,ylen
      common/ basic /n4,ifont,icopt,iwidth,iop0

c psytic - subroutine to draw y-axis ticks.

      y = y0 
      call psmove (x0,y0)

      if (ihalf.eq.0.and.itenf.eq.0) then 

10       if (y.ge.ymax) goto 99
         call psrlin (tic,0.,rline,iwidth)
         call psrmov (-tic,dy)
         y = y + dy 
         goto 10

      else if (itenf.eq.0) then

         dy2 = dy / 2.

20       if (y.ge.ymax) goto 30
         call psrlin (tic,0.,rline,iwidth)
         call psrmov (-tic,dy2)
         y = y + dy2
         if (y.ge.ymax) goto 30
         call psrlin (tic1, 0., rline, iwidth)
         call psrmov (-tic1,dy2)
         y = y + dy2
         goto 20

30       if (y0-dy2.gt.ymin)
     *      call psline (x0,y0-dy2,x0+tic1,y0-dy2,rline,iwidth)
         goto 99

      else

         dy2 = dy / 10.

40       if (y.ge.ymax) goto 50
         call psrlin (tic, 0., rline, iwidth)
         call psrmov (-tic, dy2)
         y = y + dy2

         do 60 i = 1, 4
            if (y.ge.ymax) goto 50
            call psrlin (tic2, 0., rline, iwidth)
            call psrmov (-tic2, dy2)
60          y = y + dy2

         if (y.ge.ymax) goto 50
         call psrlin (tic1, 0., rline, iwidth)
         call psrmov (-tic1, dy2)
         y = y + dy2

         do 70 i = 1, 4
            if (y.ge.ymax) goto 50
            call psrlin (tic2, 0., rline, iwidth)
            call psrmov (-tic2, dy2)
70          y = y + dy2

         goto 40

50       if (y0-dy2.lt.ymin) goto 99

         y = y0 - dy2
         call psmove (x0,y)

         do 80 i = 1, 4
            if (y.le.ymin) goto 99
            call psrlin (tic2, 0., rline, iwidth)
            call psrmov (-tic2, -dy2)
80          y = y - dy2

         if (y.le.ymin) goto 99
         call psrlin (tic1, 0., rline, iwidth)
         call psrmov (-tic1, -dy2)
         y = y - dy2 

         do 90 i = 1, 4
            if (y.le.ymin) goto 99
            call psrlin (tic2, 0., rline, iwidth)
            call psrmov (-tic2, -dy2)
90          y = y - dy2

      end if 

99    end

c------------------------------------------------------------------
      subroutine psxtic (y0, x0, dx, tic, tic1, tic2, rline, ihalf,
     *                   itenf)

      implicit real (a-g,o-z),integer (h-n)

      common/ wsize /xmin,xmax,ymin,ymax,dcx,dcy,xlen,ylen
      common/ basic /n4,ifont,icopt,iwidth,iop0

c psxtic - subroutine to draw x-axis ticks.

      x = x0 
      call psmove (x0,y0)

      if (ihalf.eq.0.and.itenf.eq.0) then 

10       if (x.ge.xmax) goto 99
         call psrlin (0., tic, rline, iwidth)
         call psrmov (dx, -tic)
         x = x + dx 
         goto 10

      else if (itenf.eq.0) then

         dx2 = dx / 2.

20       if (x.ge.xmax) goto 30
         call psrlin (0., tic, rline, iwidth)
         call psrmov (dx2, -tic)
         x = x + dx2
         if (x.ge.xmax) goto 30
         call psrlin (0., tic1, rline, iwidth)
         call psrmov (dx2, -tic1)
         x = x + dx2
         goto 20

30       if (x0-dx2.gt.xmin)
     *      call psline (x0-dx2, y0, x0-dx2, y0+tic1, rline, iwidth)
         goto 99

      else

         dx2 = dx / 10.

40       if (x.ge.xmax) goto 50
         call psrlin (0., tic, rline, iwidth)
         call psrmov (dx2, -tic)
         x = x + dx2

         do 60 i = 1, 4
            if (x.ge.xmax) goto 50
            call psrlin (0., tic2, rline, iwidth)
            call psrmov (dx2, -tic2)
60          x = x + dx2

         if (x.ge.xmax) goto 50
         call psrlin (0., tic1, rline, iwidth)
         call psrmov (dx2, -tic1)
         x = x + dx2

         do 70 i = 1, 4
            if (x.ge.xmax) goto 50
            call psrlin (0., tic2, rline, iwidth)
            call psrmov (dx2, -tic2)
70          x = x + dx2

         goto 40

50       if (x0-dx2.lt.xmin) goto 99

         x = x0 - dx2

         call psmove (x, y0)

         do 80 i = 1, 4
            if (x.le.xmin) goto 99
            call psrlin (0., tic2, rline, iwidth)
            call psrmov (-dx2, -tic2)
80          x = x - dx2

         if (x.le.xmin) goto 99
         call psrlin (0., tic1, rline, iwidth)
         call psrmov (dx2, -tic1) 
         x = x - dx2 

         do 90 i = 1, 4
            if (x.le.xmin) goto 99
            call psrlin (0., tic2, rline, iwidth)
            call psrmov (-dx2, -tic2)
90          x = x - dx2

      end if 

99    end
 
      subroutine psylbl (xmin, xmax, y0, ymax, dy, dcx, dcy, tmin, igrd)
 
c psylbl - subroutine to put on y-axis labels.

      implicit real (a-g,o-z),integer (h-n)
 
      character*12 numbs(40)
 
      integer ic(40)

      common / xyrat /xfac

      xdc = 1.4 * dcx
      ydc = .8 * dcy
      tmin = 1e30
 
      call psnum (y0,ymax,dy,ic,iy1,numbs)
 
      y = y0
 
      do 10 i = 1, iy1
 
         t = xmin - (float(ic(i)+1) * xdc) / xfac
         if (t.lt.tmin) tmin = t
         call pstext (t, y + ydc, numbs(i), ic(i))
         if (igrd.eq.1) call psline (xmin, y, xmax, y, 10., 0)
 
10    y = y + dy
 
      end

      subroutine psnum (rmin,rmax,dr,ic,i1,numbs)

      implicit real (a-g,o-z),integer (h-n)
 
      character*1 text(12), numbs(40)*12, next(12)
 
      integer ic(40), k

      i1 = 1 + ifix ((rmax - rmin) / dr)
 
      if (rmax.gt. 9999.9 .and.rmax.lt. 99999.9 .and.rmin.gt.-rmax) then
         icase = 1
      else if (rmax.gt. 999.9 .and.rmax.le. 9999.9
     *                        .and.rmin.gt.-rmax) then
         icase = 2
      else if (rmax.gt. 99.9 .and.rmax.le. 999.9
     *                       .and.rmin.gt.-rmax) then
         icase = 3
      else
         icase = 4
      end if
 
      r = rmin
 
      do 10 i = 1, i1
         goto (1,2,3,4) icase
1        write (numbs(i),1001) ifix(r)
         goto 20
2        write (numbs(i),1002) ifix(r)
         goto 20
3        write (numbs(i),1003) ifix(r)
         goto 20
4        write (numbs(i),1004) r
20       read (numbs(i),1010) text
         k = 0
         do 30 j = 1, 12
            if (text(j).eq.' ') goto 30
            k = k + 1
            next(k) = text(j)
30       continue
         ic(i) = k
         write (numbs(i),1010) (next(j),j=1,k)
10    r = r + dr
 
1001  format (i5)
1002  format (i4)
1003  format (i3)
1004  format (g9.3)
1010  format (12a1)
 
      end
 
      subroutine psxlbl (x0, dx, dc, dyl, igrd)
 
c psxlbl - subroutine to put on x-axis labels.

      implicit real (a-g,o-z),integer (h-n)
 
      character*12 numbs(40)

      common/ wsize /xmin,xmax,ymin,ymax,dcx,dcy,xlen,ylen
 
      integer ic(40)

      common / xyrat /xfac
c
      y = ymin - dyl
 
      x = x0
 
      xdc = .75 * dc
 
      call psnum (x0,xmax,dx,ic,ix1,numbs)
 
      do 10 i = 1, ix1
         if (x.eq.xmin.or.x.eq.xmax) goto 10
         t = x - (float(ic(i)) * xdc) / xfac
         call pstext (t, y, numbs(i), ic(i))
         if (igrd.eq.1) call psline (x, ymin, x, ymax, 10., 0)
10    x = x + dx
 
      end